package de.uebungstool.uebungstool.scheduling.strategies;

import static de.uebungstool.uebungstool.scheduling.threads.SchedulingDiagramConstants.STRATEGIES_RR;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import de.uebungstool.uebungstool.scheduling.logic.SchedulingService;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingDiagram;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingKernelLevelThread;
import de.uebungstool.uebungstool.scheduling.threads.SchedulingUserLevelThread;
import java.util.Arrays;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

class RROneSchedulerIntegrationTest {
  /**
   * configuration String can be created with the client: 1. create a Configuration 2. Fill in the
   * diagram 3. Click generate 'ConfigurationString'
   *
   * <p>All values in the status field will be used to create a user input for both diagrams and it
   * will also be used as the correction values in the expected Diagram
   *
   * <p>Also save the configuration String in order to restore the configuration in browser
   */
  private SchedulingDiagram inputDiagram;

  private SchedulingDiagram expectedDiagram;

  SchedulingService schedulerService = new SchedulingService();

  /**
   * Initialises the Diagram Object with a valid RR Strategy configuration This is the same standard
   * configuration which is used in the Website.
   */
  @BeforeEach
  public void initDiagrams() {
    expectedDiagram = initDiagram();
    inputDiagram = initDiagram();
  }

  /**
   * Creates one Diagram with the standard configuration for this strategy
   *
   * @return new diagram
   */
  private SchedulingDiagram initDiagram() {
    SchedulingDiagram diagram = new SchedulingDiagram();
    diagram.setStrategy(STRATEGIES_RR);
    diagram.setOwnUserLevelScheduler(false);
    diagram.setPreemptive(false);
    diagram.setSchedulerTime(true);
    diagram.setDispatcherTime(true);
    diagram.setTimeSliceLength(2);
    diagram.setCoreNumber(1);
    diagram.setInitialScheduler(false);
    return diagram;
  }

  private boolean testConfiguration(String obj, String objKernel) throws JsonProcessingException {
    ObjectMapper objectMapper = new ObjectMapper();
    inputDiagram.userLevelThreads = objectMapper.readValue(obj, SchedulingUserLevelThread[].class);
    inputDiagram.setKernelLevelThreads(
        objectMapper.readValue(objKernel, SchedulingKernelLevelThread[].class));
    expectedDiagram.userLevelThreads =
        initThreadsExpectedDiagram(objectMapper.readValue(obj, SchedulingUserLevelThread[].class));

    schedulerService.evaluate(inputDiagram);
    return inputDiagram.equalCorrection(expectedDiagram);
  }

  private SchedulingUserLevelThread[] initThreadsExpectedDiagram(
      SchedulingUserLevelThread[] readValue) {
    for (SchedulingUserLevelThread u : readValue) {
      Arrays.stream(u.getCells()).forEach(c -> c.setCorrected(c.getStatus()));
    }
    return readValue;
  }

  /**
   * Configuration:
   * {"strategy":3,"schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"ownUserLevelScheduler":false,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":1,"computingTime":7,"id":1000,"name":"P1_U0","startTimePrevious":1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":13,"deadlineBackup":-1},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":1,"computingTime":4,"id":1001,"name":"P1_U1","startTimePrevious":1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":19,"deadlineBackup":-1},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":1,"computingTime":10,"id":2000,"name":"P2","startTimePrevious":1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":3,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Sched./Disp.","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":3,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":2,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":1,"userID":1002,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":0,"lowestUserThreadID":1001,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":1,"userID":2001,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false}],"nextID":3,"highestStartingTime":4,"advancedConfigurationOptions":false,"showHelpGuides":true,"rrOrder":true}
   */
  @Test
  void RR_base_test() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.

    // add threads to the diagram
    String obj =
        " [{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":7,\"id\":1000,\"priority\":13},{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":4,\"id\":1001,\"priority\":19},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":10,\"id\":2000,\"priority\":3},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":3}],\"rrOrder\":true"
            + " ";
    String objKernel =
        " [{\"kernelthreadID\":1,\"userStrategy\":0,\"startTime\":1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":2,\"userStrategy\":0,\"startTime\":1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Three threads one ending before others start, third arrives after first is scheduled
   * {"strategy":3,"schedulerTime":false,"dispatcherTime":true,"userSchedulerTime":false,"ownUserLevelScheduler":false,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":4,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":4,"computingTime":7,"id":4000,"name":"P1","startTimePrevious":4,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":13,"deadlineBackup":-1},{"parentid":5,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":1,"computingTime":1,"id":5000,"name":"P2","startTimePrevious":1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":18,"deadlineBackup":-1},{"parentid":6,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":3,"computingTime":4,"id":6000,"name":"P3","startTimePrevious":3,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":13,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Sched./Disp.","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":7,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":2,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":3,"userID":4001,"kernelThreadName":"P4","kernelthreadID":4,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":1,"userID":5001,"kernelThreadName":"P5","kernelthreadID":5,"userStrategy":0,"lowestUserThreadID":5000,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":3,"userID":6001,"kernelThreadName":"P6","kernelthreadID":6,"userStrategy":0,"lowestUserThreadID":6000,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false}],"nextID":7,"highestStartingTime":8,"advancedConfigurationOptions":true,"showHelpGuides":true,"rrOrder":true}
   */
  @Test
  void RR_ending_before_next_starts() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setTimeSliceLength(2);
    inputDiagram.setSchedulerTime(false);
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        " [{\"parentid\":4,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":4,\"computingTime\":7,\"id\":4000,\"priority\":13},{\"parentid\":5,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":1,\"computingTime\":1,\"id\":5000,\"priority\":18},{\"parentid\":6,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":3,\"computingTime\":4,\"id\":6000,\"priority\":13},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":7}],\"rrOrder\":true"
            + " \n";
    String objKernel =
        " [{\"kernelthreadID\":4,\"userStrategy\":0,\"startTime\":3,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":5,\"userStrategy\":0,\"startTime\":1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":6,\"userStrategy\":0,\"startTime\":3,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Tutorial sheet 3 task 2 c Configuration:
   * {"strategy":3,"schedulerTime":false,"dispatcherTime":true,"userSchedulerTime":false,"ownUserLevelScheduler":false,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":0,"computingTime":7,"id":1000,"name":"P1","startTimePrevious":0,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":3,"deadlineBackup":-1},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":5,"computingTime":3,"id":2000,"name":"P2","startTimePrevious":5,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":17,"deadlineBackup":-1},{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":2,"computingTime":4,"id":3000,"name":"P3","startTimePrevious":2,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":6,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Sched./Disp.","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":1,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":1,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1001,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":2,"userID":2001,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":0,"userID":3001,"kernelThreadName":"P3","kernelthreadID":3,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false}],"nextID":5,"highestStartingTime":7,"advancedConfigurationOptions":true,"showHelpGuides":true,"rrOrder":true}
   */
  @Test
  void RR_tutorial_task_test() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setTimeSliceLength(1);
    inputDiagram.setSchedulerTime(false);
    // add threads to the diagram
    String obj =
        " [{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":7,\"id\":1000,\"priority\":3},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":3,\"id\":2000,\"priority\":17},{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":4,\"id\":3000,\"priority\":6},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":1}],\"rrOrder\":true"
            + " ";
    String objKernel =
        " [{\"kernelthreadID\":1,\"userStrategy\":0,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":2,\"userStrategy\":0,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":3,\"userStrategy\":0,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Tutorial sheet 3 task 2 c Configuration:
   * {"strategy":3,"schedulerTime":false,"dispatcherTime":true,"userSchedulerTime":false,"ownUserLevelScheduler":false,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":0,"computingTime":7,"id":1000,"name":"P1","startTimePrevious":0,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":3,"deadlineBackup":-1},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":5,"computingTime":3,"id":2000,"name":"P2","startTimePrevious":5,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":17,"deadlineBackup":-1},{"parentid":3,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":2,"computingTime":4,"id":3000,"name":"P3","startTimePrevious":2,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":6,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Sched./Disp.","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":1,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":1,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1001,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":2,"userID":2001,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":0,"userID":3001,"kernelThreadName":"P3","kernelthreadID":3,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false}],"nextID":5,"highestStartingTime":7,"advancedConfigurationOptions":true,"showHelpGuides":true,"rrOrder":true}
   */
  @Test
  void RR_sort_by_time_test() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setTimeSliceLength(1);
    inputDiagram.setSchedulerTime(false);
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        " [{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":7,\"id\":1000,\"priority\":3},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":5,\"computingTime\":3,\"id\":2000,\"priority\":17},{\"parentid\":3,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":4,\"id\":3000,\"priority\":6},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":1}],\"rrOrder\":true"
            + "   ";
    String objKernel =
        " [{\"kernelthreadID\":1,\"userStrategy\":0,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":2,\"userStrategy\":0,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":3,\"userStrategy\":0,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }

  /**
   * Tutorial sheet 3 task 2 c Configuration:
   * {"strategy":3,"schedulerTime":true,"dispatcherTime":true,"userSchedulerTime":true,"ownUserLevelScheduler":false,"preemptive":false,"initialScheduler":false,"allUserLevelThreads":[{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":2,"computingTime":5,"id":1000,"name":"P1_U0","startTimePrevious":2,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":5,"deadlineBackup":-1},{"parentid":1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":0,"computingTime":3,"id":1001,"name":"P1_U1","startTimePrevious":0,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":13,"deadlineBackup":-1},{"parentid":2,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":2,"computingTime":9,"id":2000,"name":"P2","startTimePrevious":2,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":13,"deadlineBackup":-1},{"parentid":-1,"ioAftern":-1,"ioLength":-1,"deadline":-1,"startTime":-1,"computingTime":-1,"id":-1,"name":"Sched./Disp.","startTimePrevious":-1,"deadlinePrevious":-1,"IOInterruptionActivated":false,"priority":16,"deadlineBackup":-1}],"coreNumber":1,"timeSliceLength":5,"prioChangeComputing":-1,"prioChangeWaiting":2,"lowestPriorityFirst":false,"allKernelLevelThreads":[{"startTime":0,"userID":1002,"kernelThreadName":"P1","kernelthreadID":1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":2,"userID":2001,"kernelThreadName":"P2","kernelthreadID":2,"userStrategy":0,"lowestUserThreadID":2000,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false},{"startTime":-1,"userID":-1,"kernelThreadName":"Scheduler","kernelthreadID":-1,"userStrategy":0,"lowestUserThreadID":-1,"userlevelTimeSliceLength":2,"lowestPriorityFirstKernel":false,"prioChangeComputingKernel":-1,"prioChangeWaitingKernel":2,"userSchedulingPreemptive":false,"userlevelSchedulerArrivalTimeRR":false}],"nextID":3,"highestStartingTime":8,"advancedConfigurationOptions":false,"showHelpGuides":true,"rrOrder":true}
   */
  @Test
  void RR_longer_slice_userandkernel() throws JsonProcessingException {
    // change parameters of the default diagram which should differ from the standard configuration.
    inputDiagram.setTimeSliceLength(5);
    inputDiagram.setSchedulerTime(true);
    inputDiagram.setDispatcherTime(true);
    // add threads to the diagram
    String obj =
        " [{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":5,\"id\":1000,\"priority\":5},{\"parentid\":1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":0,\"computingTime\":3,\"id\":1001,\"priority\":13},{\"parentid\":2,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"-\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":2,\"computingTime\":9,\"id\":2000,\"priority\":13},{\"parentid\":-1,\"ioAftern\":-1,\"ioLength\":-1,\"deadline\":-1,\"cells\":[{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"X\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"},{\"status\":\"\"}],\"startTime\":-1,\"computingTime\":-1,\"id\":-1,\"priority\":16}],\"rrOrder\":true"
            + " ";
    String objKernel =
        " [{\"kernelthreadID\":1,\"userStrategy\":0,\"startTime\":0,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":2,\"userStrategy\":0,\"startTime\":2,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false},{\"kernelthreadID\":-1,\"userStrategy\":0,\"startTime\":-1,\"userlevelTimeSliceLength\":2,\"lowestPriorityFirstKernel\":false,\"prioChangeComputingKernel\":-1,\"prioChangeWaitingKernel\":2,\"userSchedulingPreemptive\":false,\"userlevelSchedulerArrivalTimeRR\":false}]"
            + " ";
    assert (testConfiguration(obj, objKernel));
  }
}
